c======================================================================|
      subroutine model(ro,pr,vx,vy,by,bx,bxm,gm,margin,x,ix
     &     ,mf_params)
c======================================================================|
      implicit double precision (a-h,o-z)
c----------------------------------------------------------------------|
      dimension dxm(ix),x(ix)
      dimension ro(ix),pr(ix),vx(ix)
      dimension vy(ix),by(ix)
      dimension bx(ix),bxm(ix)

c----------------------------------------------------------------------|
c   parameters
c----------------------------------------------------------------------|
      pi = acos(-1.0d0)
      gm=2.d0

c----------------------------------------------------------------------|
c   grid
c----------------------------------------------------------------------|
      dx0=1.d0/real(ix-margin*2)

      do i=1,ix
         dxm(i)=dx0
      enddo

      izero=ix/2
        x(izero)=-dxm(izero)/2
        do i=izero+1,ix
           x(i) = x(i-1)+dxm(i-1)
        enddo
        do i=izero-1,1,-1
           x(i) = x(i+1)-dxm(i)
        enddo


c----------------------------------------------------------------------|
c     initial condition
c----------------------------------------------------------------------|

      do i=1,ix
         if (x(i).le.0) then
           ro(i)  = 1.d0
           pr(i)  = 1.d0
           by(i)  = sqrt(4.d0*pi)
         else
           ro(i)  = 0.125d0
           pr(i)  = 0.1d0
           by(i)  = -sqrt(4.d0*pi)
         endif
         vx(i) = 0.0d0
         vy(i) = 0.0d0
         bx(i) = 0.75d0*sqrt(4.d0*pi)
         bxm(i) = 0.75d0*sqrt(4.d0*pi)
      enddo
      
c----------------------------------------------------------------------|
c     write parameters to file
c----------------------------------------------------------------------|


      return
      end
